# Movable Type (r) (C) 2007 Six Apart, Ltd. All Rights Reserved.
# This code cannot be redistributed without permission from www.sixapart.com.
# For more information, consult your Movable Type license.
#
# $Id: Util.pm 69179 2007-12-11 02:34:09Z bchoate $

package MT::Community::Util;

use strict;

sub comment_post_insert {
    my ($cb, $comment) = @_;

    my $blog = $comment->blog;

    # this behavior is only for forum-type blogs
    return unless ($blog->template_set || '') =~ m/forum/;

    my $entry = $comment->entry or return;

    # "Touch" the entry by updated the modified on timestamp. This allows
    # for the forum index to be listed properly in order by modification
    # date. Replies to forum topics 'bump' the topic back up.
    $entry->modified_on($comment->created_on);
    $entry->save;

    1;
}


1;
