# Movable Type (r) (C) 2001-2008 Six Apart, Ltd. All Rights Reserved.
# This code cannot be redistributed without permission from www.sixapart.com.
# For more information, consult your Movable Type license.
#
# $Id: Error.pm 1722 2008-04-02 18:36:39Z bchoate $

package MT::TheSchwartz::Error;

use strict;
use base qw( MT::Object );

__PACKAGE__->install_properties({
    column_defs => {
        jobid => 'integer not null', # bigint unsigned not null
        funcid => 'integer not null', # int unsigned not null default 0
        message => 'string(255) not null', # varchar(255) not null
        error_time => 'integer not null', # integer unsigned not null
    },
    datasource  => 'ts_error',
    indexes => {
        jobid => 1,
        funcid_time => {
            columns => ['funcid', 'error_time'],
        },
    },
    defaults => {
        funcid => 0,
    },
    cacheable => 0,
});

sub class_label {
    MT->translate("Job Error");
}

1;
